import 'dart:collection';

import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';

class ForceUpdateKey implements Listenable {
  LinkedList<_ListenerEntry> _listeners = LinkedList<_ListenerEntry>();

  @override
  void addListener(listener) {
    _listeners.add(_ListenerEntry(listener));
  }

  @override
  void removeListener(listener) {
    for (final _ListenerEntry entry in _listeners) {
      if (entry.listener == listener) {
        entry.unlink();
        return;
      }
    }
  }

  void update() {
    for (final _ListenerEntry entry in _listeners) {
      if (entry.list != null) entry.listener();
    }
  }
}

class _ListenerEntry extends LinkedListEntry<_ListenerEntry> {
  _ListenerEntry(this.listener);
  final VoidCallback listener;
}
